/* xopen.c  93.12.21
 * Copyright 1983-1992   Albert Davis
 * scan a string for a file name
 * fill in extension, if necessary
 * open file
 */
#include "ecah.h"
#include "error.h"
#include <time.h>
#include "declare.h"
/*--------------------------------------------------------------------------*/
	void	xclose(FILE**);
	FILE*	xopen(const char*,int*,const char*,const char*);
/*--------------------------------------------------------------------------*/
extern FILE *stream[];
/*--------------------------------------------------------------------------*/
void xclose(FILE **fn)
{
 if (*fn){
    (void)fclose(*fn);
    *fn = (FILE*)NULL;
 }
}
/*--------------------------------------------------------------------------*/
FILE *xopen(const char *cmd, int *cnt, const char *ext, const char *how)
{
 int i;
 int defalt;
 FILE *code;
 char fname[BUFLEN+5];

 skipbl(cmd,cnt);
 if (!cmd[*cnt]){
    int loccount;
    cmd = getcmd ("file name?  ",fname,BUFLEN);
    loccount = 0;
    cnt = &loccount;
 }

 skipbl(cmd,cnt);			/* find out if we want to add the   */
 defalt = YES;				/* default extension		    */
 for (i = 0;   i < BUFLEN;   ){
    char c;
    c = cmd[(*cnt)++];
    if (isterm(c))
       break;
    if (c == '$'){
       sprintf(&(fname[i]), "%ld", (long)time((time_t*)NULL));
       i = strlen(fname);
    }else{
       fname[i++] = c;
       if (c == '.')
          defalt = NO;
       else if (c == '\\'  ||  c == '/')
          defalt = YES;
    }
 }
 (*cnt)--;
 if (defalt){				/* add the extension		    */
    fname[i++] = '.';
    strcpy(&fname[i],ext);
 }else{
    fname[i] = '\0';
 }
 
 (void)trim(fname);
 skipcom(cmd,cnt);

 if ((*how == 'w')   &&   (access(fname,F_OK) == GOOD)){
    char buffer[BUFLEN];		
    error(bWARNING, "%s exists.  replace? ", fname);
    (void)getcmd ("", buffer, BUFLEN);
    if (match(buffer,"Yes"))		/* should be new file, but	    */
	code = fopen(fname,how);	/* file already exists,  ask	    */
    else
	return (FILE*)NULL;
 }else{
    code = fopen(fname,how);
 }

 if (code && fileno(code)>MAXHANDLE){
    error(bWARNING, "internal error: files: %d\n", fileno(code));
    (void)fclose(code);
    code = (FILE*)NULL;
 }
 if (code)
    stream[(int)fileno(code)] = code;
 else
    error(bWARNING, "can't open %s\n", fname);
 return code;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
